/* history.c generated by valac 0.56.18, the Vala compiler
 * generated from history.vala, do not modify */

/* History facility functions

   Copyright (c) 2004-2020 Free Software Foundation, Inc.

   This file is part of GNU Zile.

   GNU Zile is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Zile is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, see <https://www.gnu.org/licenses/>.  */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;
typedef struct _HistoryPrivate HistoryPrivate;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _ParamSpecHistory ParamSpecHistory;

struct _History {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HistoryPrivate * priv;
};

struct _HistoryClass {
	GTypeClass parent_class;
	void (*finalize) (History *self);
};

struct _HistoryPrivate {
	GList* elements;
	guint* sel;
};

struct _ParamSpecHistory {
	GParamSpec parent_instance;
};

static gint History_private_offset;
static gpointer history_parent_class = NULL;

VALA_EXTERN gpointer history_ref (gpointer instance);
VALA_EXTERN void history_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_history (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_history (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_history (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_history (const GValue* value);
VALA_EXTERN GType history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (History, history_unref)
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN History* history_new (void);
VALA_EXTERN History* history_construct (GType object_type);
VALA_EXTERN void history_add_element (History* self,
                          const gchar* s);
VALA_EXTERN void history_prepare (History* self);
VALA_EXTERN const gchar* history_previous_element (History* self);
static guint* _uint_dup (guint* self);
VALA_EXTERN const gchar* history_next_element (History* self);
static void history_finalize (History * obj);
static GType history_get_type_once (void);

static inline gpointer
history_get_instance_private (History* self)
{
	return G_STRUCT_MEMBER_P (self, History_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 21 "src/history.vala"
	var = (g_free (var), NULL);
#line 122 "history.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 21 "src/history.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 130 "history.c"
}

History*
history_construct (GType object_type)
{
	History* self = NULL;
#line 24 "src/history.vala"
	self = (History*) g_type_create_instance (object_type);
#line 25 "src/history.vala"
	(self->priv->elements == NULL) ? NULL : (self->priv->elements = (_g_list_free__g_free0_ (self->priv->elements), NULL));
#line 25 "src/history.vala"
	self->priv->elements = NULL;
#line 24 "src/history.vala"
	return self;
#line 145 "history.c"
}

History*
history_new (void)
{
#line 24 "src/history.vala"
	return history_construct (TYPE_HISTORY);
#line 153 "history.c"
}

void
history_add_element (History* self,
                     const gchar* s)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
#line 28 "src/history.vala"
	g_return_if_fail (self != NULL);
#line 28 "src/history.vala"
	g_return_if_fail (s != NULL);
#line 29 "src/history.vala"
	_tmp1_ = self->priv->elements;
#line 29 "src/history.vala"
	if (g_list_length (_tmp1_) == ((guint) 0)) {
#line 29 "src/history.vala"
		_tmp0_ = TRUE;
#line 172 "history.c"
	} else {
		GList* _tmp2_;
		GList* _tmp3_;
		gconstpointer _tmp4_;
#line 29 "src/history.vala"
		_tmp2_ = self->priv->elements;
#line 29 "src/history.vala"
		_tmp3_ = g_list_last (_tmp2_);
#line 29 "src/history.vala"
		_tmp4_ = _tmp3_->data;
#line 29 "src/history.vala"
		_tmp0_ = g_strcmp0 ((const gchar*) _tmp4_, s) != 0;
#line 185 "history.c"
	}
#line 29 "src/history.vala"
	if (_tmp0_) {
#line 189 "history.c"
		gchar* _tmp5_;
#line 30 "src/history.vala"
		_tmp5_ = g_strdup (s);
#line 30 "src/history.vala"
		self->priv->elements = g_list_append (self->priv->elements, _tmp5_);
#line 195 "history.c"
	}
}

void
history_prepare (History* self)
{
#line 33 "src/history.vala"
	g_return_if_fail (self != NULL);
#line 34 "src/history.vala"
	_g_free0 (self->priv->sel);
#line 34 "src/history.vala"
	self->priv->sel = NULL;
#line 208 "history.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 41 "src/history.vala"
	dup = g_new0 (guint, 1);
#line 41 "src/history.vala"
	memcpy (dup, self, sizeof (guint));
#line 41 "src/history.vala"
	return dup;
#line 221 "history.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 41 "src/history.vala"
	return self ? _uint_dup (self) : NULL;
#line 229 "history.c"
}

const gchar*
history_previous_element (History* self)
{
	guint* _tmp0_;
	const gchar* _tmp8_ = NULL;
	guint* _tmp9_;
	const gchar* result;
#line 37 "src/history.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "src/history.vala"
	_tmp0_ = self->priv->sel;
#line 39 "src/history.vala"
	if (_tmp0_ == NULL) {
#line 245 "history.c"
		GList* _tmp1_;
#line 40 "src/history.vala"
		_tmp1_ = self->priv->elements;
#line 40 "src/history.vala"
		if (g_list_length (_tmp1_) > ((guint) 0)) {
#line 251 "history.c"
			GList* _tmp2_;
			guint _tmp3_;
			guint* _tmp4_;
#line 41 "src/history.vala"
			_tmp2_ = self->priv->elements;
#line 41 "src/history.vala"
			_tmp3_ = g_list_length (_tmp2_) - 1;
#line 41 "src/history.vala"
			_tmp4_ = __uint_dup0 (&_tmp3_);
#line 41 "src/history.vala"
			_g_free0 (self->priv->sel);
#line 41 "src/history.vala"
			self->priv->sel = _tmp4_;
#line 265 "history.c"
		}
	} else {
		guint* _tmp5_;
#line 42 "src/history.vala"
		_tmp5_ = self->priv->sel;
#line 42 "src/history.vala"
		if ((*_tmp5_) > ((guint) 0)) {
#line 273 "history.c"
			guint* _tmp6_;
			guint* _tmp7_;
#line 44 "src/history.vala"
			_tmp6_ = self->priv->sel;
#line 44 "src/history.vala"
			self->priv->sel = _tmp6_ - 1;
#line 44 "src/history.vala"
			_tmp7_ = _tmp6_;
#line 44 "src/history.vala"
			_g_free0 (_tmp7_);
#line 284 "history.c"
		}
	}
#line 47 "src/history.vala"
	_tmp9_ = self->priv->sel;
#line 47 "src/history.vala"
	if (_tmp9_ == NULL) {
#line 47 "src/history.vala"
		_tmp8_ = NULL;
#line 293 "history.c"
	} else {
		GList* _tmp10_;
		guint* _tmp11_;
		gconstpointer _tmp12_;
#line 47 "src/history.vala"
		_tmp10_ = self->priv->elements;
#line 47 "src/history.vala"
		_tmp11_ = self->priv->sel;
#line 47 "src/history.vala"
		_tmp12_ = g_list_nth_data (_tmp10_, *_tmp11_);
#line 47 "src/history.vala"
		_tmp8_ = (const gchar*) _tmp12_;
#line 306 "history.c"
	}
#line 47 "src/history.vala"
	result = _tmp8_;
#line 47 "src/history.vala"
	return result;
#line 312 "history.c"
}

const gchar*
history_next_element (History* self)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
	const gchar* _tmp7_ = NULL;
	guint* _tmp8_;
	const gchar* result;
#line 50 "src/history.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "src/history.vala"
	_tmp1_ = self->priv->elements;
#line 51 "src/history.vala"
	if (g_list_length (_tmp1_) > ((guint) 0)) {
#line 329 "history.c"
		guint* _tmp2_;
#line 51 "src/history.vala"
		_tmp2_ = self->priv->sel;
#line 51 "src/history.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 335 "history.c"
	} else {
#line 51 "src/history.vala"
		_tmp0_ = FALSE;
#line 339 "history.c"
	}
#line 51 "src/history.vala"
	if (_tmp0_) {
#line 343 "history.c"
		guint* _tmp3_;
		GList* _tmp4_;
#line 53 "src/history.vala"
		_tmp3_ = self->priv->sel;
#line 53 "src/history.vala"
		_tmp4_ = self->priv->elements;
#line 53 "src/history.vala"
		if (((*_tmp3_) + 1) < g_list_length (_tmp4_)) {
#line 352 "history.c"
			guint* _tmp5_;
			guint* _tmp6_;
#line 54 "src/history.vala"
			_tmp5_ = self->priv->sel;
#line 54 "src/history.vala"
			self->priv->sel = _tmp5_ + 1;
#line 54 "src/history.vala"
			_tmp6_ = _tmp5_;
#line 54 "src/history.vala"
			_g_free0 (_tmp6_);
#line 363 "history.c"
		} else {
#line 56 "src/history.vala"
			_g_free0 (self->priv->sel);
#line 56 "src/history.vala"
			self->priv->sel = NULL;
#line 369 "history.c"
		}
	}
#line 59 "src/history.vala"
	_tmp8_ = self->priv->sel;
#line 59 "src/history.vala"
	if (_tmp8_ == NULL) {
#line 59 "src/history.vala"
		_tmp7_ = NULL;
#line 378 "history.c"
	} else {
		GList* _tmp9_;
		guint* _tmp10_;
		gconstpointer _tmp11_;
#line 59 "src/history.vala"
		_tmp9_ = self->priv->elements;
#line 59 "src/history.vala"
		_tmp10_ = self->priv->sel;
#line 59 "src/history.vala"
		_tmp11_ = g_list_nth_data (_tmp9_, *_tmp10_);
#line 59 "src/history.vala"
		_tmp7_ = (const gchar*) _tmp11_;
#line 391 "history.c"
	}
#line 59 "src/history.vala"
	result = _tmp7_;
#line 59 "src/history.vala"
	return result;
#line 397 "history.c"
}

static void
value_history_init (GValue* value)
{
#line 20 "src/history.vala"
	value->data[0].v_pointer = NULL;
#line 405 "history.c"
}

static void
value_history_free_value (GValue* value)
{
#line 20 "src/history.vala"
	if (value->data[0].v_pointer) {
#line 20 "src/history.vala"
		history_unref (value->data[0].v_pointer);
#line 415 "history.c"
	}
}

static void
value_history_copy_value (const GValue* src_value,
                          GValue* dest_value)
{
#line 20 "src/history.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "src/history.vala"
		dest_value->data[0].v_pointer = history_ref (src_value->data[0].v_pointer);
#line 427 "history.c"
	} else {
#line 20 "src/history.vala"
		dest_value->data[0].v_pointer = NULL;
#line 431 "history.c"
	}
}

static gpointer
value_history_peek_pointer (const GValue* value)
{
#line 20 "src/history.vala"
	return value->data[0].v_pointer;
#line 440 "history.c"
}

static gchar*
value_history_collect_value (GValue* value,
                             guint n_collect_values,
                             GTypeCValue* collect_values,
                             guint collect_flags)
{
#line 20 "src/history.vala"
	if (collect_values[0].v_pointer) {
#line 451 "history.c"
		History * object;
		object = collect_values[0].v_pointer;
#line 20 "src/history.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "src/history.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 458 "history.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "src/history.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 462 "history.c"
		}
#line 20 "src/history.vala"
		value->data[0].v_pointer = history_ref (object);
#line 466 "history.c"
	} else {
#line 20 "src/history.vala"
		value->data[0].v_pointer = NULL;
#line 470 "history.c"
	}
#line 20 "src/history.vala"
	return NULL;
#line 474 "history.c"
}

static gchar*
value_history_lcopy_value (const GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
	History ** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "src/history.vala"
	if (!object_p) {
#line 20 "src/history.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 489 "history.c"
	}
#line 20 "src/history.vala"
	if (!value->data[0].v_pointer) {
#line 20 "src/history.vala"
		*object_p = NULL;
#line 495 "history.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "src/history.vala"
		*object_p = value->data[0].v_pointer;
#line 499 "history.c"
	} else {
#line 20 "src/history.vala"
		*object_p = history_ref (value->data[0].v_pointer);
#line 503 "history.c"
	}
#line 20 "src/history.vala"
	return NULL;
#line 507 "history.c"
}

GParamSpec*
param_spec_history (const gchar* name,
                    const gchar* nick,
                    const gchar* blurb,
                    GType object_type,
                    GParamFlags flags)
{
	ParamSpecHistory* spec;
#line 20 "src/history.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HISTORY), NULL);
#line 20 "src/history.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "src/history.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "src/history.vala"
	return G_PARAM_SPEC (spec);
#line 526 "history.c"
}

gpointer
value_get_history (const GValue* value)
{
#line 20 "src/history.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HISTORY), NULL);
#line 20 "src/history.vala"
	return value->data[0].v_pointer;
#line 536 "history.c"
}

void
value_set_history (GValue* value,
                   gpointer v_object)
{
	History * old;
#line 20 "src/history.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HISTORY));
#line 20 "src/history.vala"
	old = value->data[0].v_pointer;
#line 20 "src/history.vala"
	if (v_object) {
#line 20 "src/history.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HISTORY));
#line 20 "src/history.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "src/history.vala"
		value->data[0].v_pointer = v_object;
#line 20 "src/history.vala"
		history_ref (value->data[0].v_pointer);
#line 558 "history.c"
	} else {
#line 20 "src/history.vala"
		value->data[0].v_pointer = NULL;
#line 562 "history.c"
	}
#line 20 "src/history.vala"
	if (old) {
#line 20 "src/history.vala"
		history_unref (old);
#line 568 "history.c"
	}
}

void
value_take_history (GValue* value,
                    gpointer v_object)
{
	History * old;
#line 20 "src/history.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HISTORY));
#line 20 "src/history.vala"
	old = value->data[0].v_pointer;
#line 20 "src/history.vala"
	if (v_object) {
#line 20 "src/history.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HISTORY));
#line 20 "src/history.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "src/history.vala"
		value->data[0].v_pointer = v_object;
#line 589 "history.c"
	} else {
#line 20 "src/history.vala"
		value->data[0].v_pointer = NULL;
#line 593 "history.c"
	}
#line 20 "src/history.vala"
	if (old) {
#line 20 "src/history.vala"
		history_unref (old);
#line 599 "history.c"
	}
}

static void
history_class_init (HistoryClass * klass,
                    gpointer klass_data)
{
#line 20 "src/history.vala"
	history_parent_class = g_type_class_peek_parent (klass);
#line 20 "src/history.vala"
	((HistoryClass *) klass)->finalize = history_finalize;
#line 20 "src/history.vala"
	g_type_class_adjust_private_offset (klass, &History_private_offset);
#line 613 "history.c"
}

static void
history_instance_init (History * self,
                       gpointer klass)
{
#line 20 "src/history.vala"
	self->priv = history_get_instance_private (self);
#line 20 "src/history.vala"
	self->ref_count = 1;
#line 624 "history.c"
}

static void
history_finalize (History * obj)
{
	History * self;
#line 20 "src/history.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY, History);
#line 20 "src/history.vala"
	g_signal_handlers_destroy (self);
#line 21 "src/history.vala"
	(self->priv->elements == NULL) ? NULL : (self->priv->elements = (_g_list_free__g_free0_ (self->priv->elements), NULL));
#line 22 "src/history.vala"
	_g_free0 (self->priv->sel);
#line 639 "history.c"
}

static GType
history_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_history_init, value_history_free_value, value_history_copy_value, value_history_peek_pointer, "p", value_history_collect_value, "p", value_history_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (HistoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) history_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (History), 0, (GInstanceInitFunc) history_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType history_type_id;
	history_type_id = g_type_register_fundamental (g_type_fundamental_next (), "History", &g_define_type_info, &g_define_type_fundamental_info, 0);
	History_private_offset = g_type_add_instance_private (history_type_id, sizeof (HistoryPrivate));
	return history_type_id;
}

GType
history_get_type (void)
{
	static volatile gsize history_type_id__once = 0;
	if (g_once_init_enter (&history_type_id__once)) {
		GType history_type_id;
		history_type_id = history_get_type_once ();
		g_once_init_leave (&history_type_id__once, history_type_id);
	}
	return history_type_id__once;
}

gpointer
history_ref (gpointer instance)
{
	History * self;
	self = instance;
#line 20 "src/history.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "src/history.vala"
	return instance;
#line 675 "history.c"
}

void
history_unref (gpointer instance)
{
	History * self;
	self = instance;
#line 20 "src/history.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "src/history.vala"
		HISTORY_GET_CLASS (self)->finalize (self);
#line 20 "src/history.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 689 "history.c"
	}
}

